	.file	"memchr.S"

	.section .text
	
	.global  _memchr
	.type	 _memchr,@function
_memchr:
	;; R1: string pointer
	;; R2: byte sought
	;; R3: max number to scan
#ifdef __RX_ALLOW_STRING_INSNS__
	cmp	#1, r3		; If r3 is 0 suntil.b will not set any flags, so prepare a non zero condition
	suntil.b    		; Search until *r1 == r2 or r3 bytes have been examined.
	stnz	#1, r1		; If no match was found return NULL.
	sub	#1, r1		; suntil.b leaves r1 pointing at the address *after* the match.
	rts
#else
1:	sub	#1, r3
	bltu	2f
	movu.b	[r1+], r4
	cmp	r4, r2
	bne	1b
	sub	#1, r1		; We have found a match, but now R1 points to the byte after the match.
	rts
2:	mov	#0, r1
	rts
#endif
	.size _memchr, . - _memchr
	
