	.file	"memcpy.S"

	.section .text
	.global  _memcpy
	.type	 _memcpy,@function
_memcpy:
	;; R1: string pointer
	;; R2: string pointer
	;; R3: bytes to copy
#ifdef __RX_ALLOW_STRING_INSNS__
	mov	r1, r4		; Save a copy of DEST
	smovf	    		; Copy R2 (source) to R1 (dest).  Stop after R3 bytes.
	mov	r4, r1		; Return DEST
	rts
#else
	/* Do not use the string instructions - they might prefetch
	   bytes from outside of valid memory.  This is particularly
	   dangerous in I/O space.  */
	cmp	#0, r3
	beq	2f
	mov	r1, r4		; use a copy of DEST
1:	mov.b	[r2+], r5
	mov.b	r5, [r4+]
	sub	#1, r3
	bne	1b
2:	rts
#endif
	.size _memcpy, . - _memcpy
