	.file	"mempcpy.S"

	.section .text
	.global  _mempcpy
	.type	 _mempcpy,@function
_mempcpy:
	;; R1: string pointer
	;; R2: string pointer
	;; R3: bytes to copy
#ifdef __RX_ALLOW_STRING_INSNS__
	smovf
	rts
#else
	/* Do not use the string instructions - they might prefetch
	   bytes from outside of valid memory.  This is particularly
	   dangerous in I/O space.  */

	cmp	 #0, r3	      	; If the count is zero, do nothing
	beq	 2f
1:	mov.b	 [r2+], r4
	mov.b	 r4, [r1+]
	sub	 #1, r3
	bne	 1b
2:	rts
#endif
	.size _mempcpy, . - _mempcpy
