	.file	"stpncpy.S"

	.section .text
	.global  _stpncpy
	.type	 _stpncpy,@function
_stpncpy:
	;; R1: destination string pointer
	;; R2: source string pointer
	;; R3: number of bytes to be copied
#ifdef __RX_ALLOW_STRING_INSNS__
	mov	r3, r4		; Prepare for r3=0 cornercase
	smovu
	cmp	#0, r3
	beq 1f
	mov	r1, r4
	mov	#0, r2
	sstr.b
	add	#-1, r4, r1
	rts
1:	mov.b	[-r1], r2
	cmp	#0, r2		; Check if end of string
	stnz	#1, r2
	cmp	#0, r4		; Check for cornercase r3 = 0
	stz	#1, r2
	add	r2, r1		; Bunch of workarounds to return correct pointer
	rts
#else
	cmp	#0, r3
	beq	4f
1:	mov.b	[r2+], r4
	mov.b	r4, [r1+]
	cmp	#0, r4
	beq	2f
	sub	#1, r3
	bne	1b
	rts
2:	sub	#1, r1		; Store pointer to the \0 char
	cmp	#0, r3		; Corner case of \0 at end of array
	beq	4f
	add	#1, r1, r2	; Move pointer to r2, we have \0 in r4
3:	mov.b	r4, [r2+]
	sub	#1, r3
	bne	3b
4:	rts
#endif
	.size _stpncpy, . - _stpncpy
