	.file	"strcat.S"

	.section .text
	.global  _strcat
	.type	 _strcat,@function
_strcat:
	;; R1 : Destination
	;; R2 : Source
#ifdef __RX_ALLOW_STRING_INSNS__
	mov 	r1, r4		; Save a copy of the dest pointer.
	mov 	r2, r5		; Save a copy of the source pointer.
	mov	#0, r2		; Search for the NUL byte.
	not 	r2, r3		; No limit on the number of bytes examined.
	suntil.b		; Find the end of the destination string.
	sub	#1, r1		; suntil.b leaves r1 pointing to the byte beyond the NUL.
	not 	r2, r3		; No limit on the number of bytes copied	
	mov	r5, r2		; Restore the source pointer.		
	smovu			; Copy source to destination
	mov	r4, r1		; Return the original dest pointer.
	rts
#else
	mov 	r1, r4		; Save a copy of the dest pointer.
	
1:	mov.b	[r4+], r5	; Find the NUL byte at the end of R4.
	cmp	#0, r5
	bne	1b

	sub	#1, r4		; Move R4 back to point at the NUL byte.

2:	mov.b	[r2+], r5	; Copy bytes from R2 to R4 until we reach a NUL byte.
	mov.b	r5, [r4+]
	cmp	#0, r5
	bne 	2b

	rts
#endif
	.size _strcat, . - _strcat
	
