	.file	"strncpy.S"

	.section .text
	.global  _strncpy
	.type	 _strncpy,@function
_strncpy:
	;; R1: dest
	;; R2: source
	;; R3: bytes to copy
#ifdef __RX_ALLOW_STRING_INSNS__
	mov	r1, r4		; Save a copy of the dest pointer.
	smovu	    		; Copy the bytes
	mov	#0, r2		; Fill the remaining bytes with NULs,
	sstr.b
	mov	r4, r1		; Return the destination pointer
	rts
#else
	cmp	#0, r3
	beq	3f
	mov	r1, r4		; Preserve R1 for the return value.
1:	mov.b	[r2+], r5	; Copy bytes until...
	mov.b	r5, [r4+]
	sub	#1, r3
	beq	3f		; ... our count reaches zero
	cmp	#0, r5
	bne	1b		; ... or we have written a NUL byte
2:	mov.b	r5, [r4+]	; Continue to write further NUL bytes
	sub	#1, r3
	bne	2b		; until the count reaches zero.
3:	rts
	
#endif
	.size _strncpy, . - _strncpy
	
