	.file	"memcmp.S"

	.section .text
	
	.global  _memcmp
	.type	 _memcmp,@function
_memcmp:
	;; R1: string pointer
	;; R2: string pointer
	;; R3: max number to scan
#ifdef __RX_ALLOW_STRING_INSNS__
	cmp	#0, r3		; If r3 is 0 scmpu will not set any flags, so prepare a zero condition       
1:	scmpu
	bne	2f
	cmp	#0, r3		; all is good, but scmpu might have exited early in case of str1=str2=0
	bne	1b 		; need to do another loop
	mov	#0, r1		; made sure to check entire r3 items, return 0
	rts
2:	sub	#1, r1		; scmpu leaves r1 pointing at the adress *after* the diff
	sub	#1, r2		; scmpu leaves r2 pointing at the adress *after* the diff
	movu.b	[r1], r1
	movu.b	[r2], r2
	sub	r2, r1		; calculate the difference
	rts
#else
1:	sub	#1, r3
	bltu	2f
	movu.b	[r1+], r4
	movu.b	[r2+], r5
	sub	r5, r4
	beq	1b
	mov	r4, r1
	rts
2:	mov	#0, r1
	rts
#endif
	.size _memcmp, . - _memcmp
